
import java.util.HashSet;
import java.util.Set;


/**
 *
 * @author YOUR NAME HERE <EMAIL@dukes.jmu.edu>
 *
 *         HONOR STATEMENT HERE
 */
public class QuadTreeNode<E extends BoxIntersectable> {

  protected Box region;

  protected QuadTreeNode<E> northEast;
  protected QuadTreeNode<E> northWest;
  protected QuadTreeNode<E> southEast;
  protected QuadTreeNode<E> southWest;

  protected int depth;

  public static final int MAX_SPRITES = 20;
  public static final int MAX_DEPTH = 20;

  // The sprites stored
  HashSet<E> sprites;

  public QuadTreeNode(Box bbox, int depth) {
    sprites = new HashSet<>();
    northEast = northWest = southEast = southWest = null;
    this.region = bbox;
    this.depth = depth;
  }

  /**
   * Add the item to this quadtree node.
   * 
   * <p>
   * If this node is an internal node, recursively add the item to any children of this node whose
   * regions intersect the item's box.
   * </p>
   * 
   * <p>
   * If this is a leaf node, store the item in a set that is contained within the node. If the
   * number of items stored within the node exceeds some threshold (e.g. MAX_SPRITES in
   * QuadTreeSpriteNode), but is not at some maximum depth (e.g. MAX_DEPTH in QuadTreeSpriteNode),
   * then split this node by dividing its region evenly among four new child nodes and adding all of
   * its nodes to the children.
   * </p>
   * 
   * @param item The item to add. 
   */
  public void add(E item) {
    throw new UnsupportedOperationException("TODO Implement This");
  }
  
  /**
   * Find all items intersecting a given bounding box.
   * 
   * <p>
   * Hints: Use a recursive algorithm with a helper. Create a HashSet to store the items and pass it
   * to the recursive calls.
   * </p>
   * 
   * <p>
   * Recurse on any child node whose region intersects the box. At a leaf node test each item stored
   * in the node to see if it intersects the box. If it does, add it to the HashSet that is
   * returned.
   * </p>
   * @param box The box to intersect objects with.
   * @return A set containing all of the items.
   */
  public Set<E> findIntersecting(Box box) {
    throw new UnsupportedOperationException("TODO Implement This");
  }

  /**
   * Remove the item from this quadtree
   * 
   * <p>
   * Hints: Similar to find. Recursively find all leaf nodes that intersect the item's bounding box
   * and remove the item from the leaf node, if it exists.
   * </p>
   * 
   * @param item The item to remove.
   * @return
   */
  public boolean remove(E sprite) {
    throw new UnsupportedOperationException("TODO Implement This");
  }

  /**
   * Return a set containing all of the items.
   * 
   * <p>
   * Hints: Use a recursive strategy. Create a set and pass it to a helper. The helper will recurse
   * on all children to get down to leaf nodes. At a leaf node call addAll on the HashSet to add all
   * items stored in that leaf.
   * </p>
   * @return A set containing all of the items in this quadtree.
   */
  public Set<E> allItems() {
    throw new UnsupportedOperationException("TODO Implement This");
  }

  private void splitNode() {
    // It may be helpful to implement this splitNode() method
    // to handle the actual splitting of a node.
    throw new UnsupportedOperationException("TODO Implement This");
  }

  /**
   * Determine if this node is a leaf or not.
   * 
   * @return True if this is a leaf, false otherwise.
   */
  public boolean isLeaf() {
    throw new UnsupportedOperationException("TODO Implement This");
  }

  /**
   * Hints:
   * 
   * <p>
   * Recursively test if the item is contained in the node. Similar to find.
   * </p>
   * 
   * @param item The item to test for. 
   * @return True if this tree contains this item.
   */
  public boolean contains(E sprite) {
    throw new UnsupportedOperationException("TODO Implement This");
  }

  /**
   * 
   * @return The box representing the region this quadtree node covers.
   */
  public Box getBoxRegion() {
    throw new UnsupportedOperationException("TODO Implement This");
  }


}
